#include "button.h"
#include "delay.h"

uint16_t button1_press_time=0, button2_press_time=0, button3_press_time=0;
/**
 * @brief GPIO按键时钟初始化
 * 
 */
static void RCC_Configuration(void)
{
    RCC_EnableAPB2PeriphClk( RCC_APB2_PERIPH_GPIOA, ENABLE );
}
/**
 * @brief 初始化按键GPIO
 * 
 */
static void GPIO_Init_Configuration(void)
{
    GPIO_InitType GPIO_Init;

    GPIO_Init.Pin       = Button1_Pin | Button2_Pin | Button3_Pin;
    GPIO_Init.GPIO_Mode = GPIO_Mode_Input;
    GPIO_Init.GPIO_Pull = GPIO_Pull_Up;
    GPIO_InitPeripheral( Button_Port, &GPIO_Init );
}
/**
 * @brief 按键初始化
 * 
 */
void Button_Init(void)
{
    RCC_Configuration();
    GPIO_Init_Configuration();
}
/**
 * @brief 按键处理程序
 * 
 * @return uint8_t 
 */
uint8_t Button_Process(void)
{
    while ( !GPIO_ReadInputDataBit( Button_Port, Button1_Pin ) )
    {
        button1_press_time++;
        delay_ms(1);//消TM的
        if( button1_press_time > 200 )
        {
            break;
        }
    }
    while ( !GPIO_ReadInputDataBit( Button_Port, Button2_Pin ) )
    {
        button2_press_time++;
        delay_ms(1);
    }
    while ( !GPIO_ReadInputDataBit( Button_Port, Button3_Pin ) )
    {
        button3_press_time++;
        delay_ms(1);
    }
    
    if( (button1_press_time < 200) && (button1_press_time >0 ) )
    {
        button1_press_time = 0;
        button2_press_time = 0;
        button3_press_time = 0;

        return Button1_Short_Press;
    }
    else if( button1_press_time > 200 )
    {
        button1_press_time = 0;
        button2_press_time = 0;
        button3_press_time = 0;
        return Button1_Long_Press;
    }

    else if( (button2_press_time < 200) && (button2_press_time >0 ) )
    {
        button1_press_time = 0;
        button2_press_time = 0;
        button3_press_time = 0;

        return Button2_Short_Press;
    }
    else if( button2_press_time > 200 )
    {
        button1_press_time = 0;
        button2_press_time = 0;
        button3_press_time = 0;
        return Button2_Long_Press;
    }

    else if( (button3_press_time < 200) && (button3_press_time >0 ) )
    {
        button1_press_time = 0;
        button2_press_time = 0;
        button3_press_time = 0;

        return Button3_Short_Press;
    }
    else if( button3_press_time > 200 )
    {
        button1_press_time = 0;
        button2_press_time = 0;
        button3_press_time = 0;
        return Button3_Long_Press;
    }

    else
    {
        button1_press_time = 0;
        button2_press_time = 0;
        button3_press_time = 0;
        
        return Button_Not_Press;
    }
    
}
