#include "ui.h"
#include "draw_api.h"
#include "moisture.h"
#include "motor.h"
#include "button.h"
#include "env_i2c.h"

int8_t selectItem = 0;//
int8_t scrollBar  = 0;//
struct Menu_t *menuPoint;//

// uint8_t temp;
// uint8_t humi;
// uint8_t solid_humi;

extern uint8_t s_hu_setup;
extern uint8_t motor_speed_setup;

uint8_t enter_set_hu=0;
uint8_t enter_set_mortor=0;

extern u8 data[6];
extern uint8_t temp;
extern uint8_t humi;
uint8_t solid_humi = 0;
extern uint16_t ADCConvertedValue;//含水量100％的时候 2200

void Set_S_Hu(void);
void Set_Mortor_Speed(void);

void GuiDataDisplayRefresh(void);
//主UI
struct MenuProperty_t MainUIProperty={1,0};
struct Menu_t MainUI=
{&MainUIProperty,"MainUI" ,NULL,NULL,NULL};

//主菜单
struct MenuProperty_t menuMainProperty={3,0};
struct Menu_t menuMain[3]=
{
	{&menuMainProperty,"last menu     ", NULL,NULL, &MainUI,NULL},
	{&menuMainProperty,"Setting       ", NULL,NULL, &MainUI,NULL},
	{&menuMainProperty,"Function      ", NULL,NULL, &MainUI,NULL},
};
//Function的子菜单
struct MenuProperty_t setMenu1Property={3,0};
struct Menu_t setMenu1[3]=
{
	{&setMenu1Property,"last menu     ",NULL,NULL,menuMain,NULL},
	{&setMenu1Property,"M_speed       ",NULL,Set_Mortor_Speed,menuMain,NULL},
	{&setMenu1Property,"S_Hu          ",NULL,Set_S_Hu,menuMain,NULL},
};
//Setting的子菜单
struct MenuProperty_t setMenu2Property={4,0};
struct Menu_t setMenu2[4]=
{
	{&setMenu2Property,"last menu      ",NULL, NULL, menuMain,NULL},
	{&setMenu2Property,"Humi 0%        ",NULL,NULL,menuMain,NULL},
	{&setMenu2Property,"Temp 0%        ",NULL, NULL,menuMain,NULL},
	{&setMenu2Property,"S_Hu 0%        ",NULL, NULL,menuMain,NULL},
};

/**
 * @brief 主界面,自己作画
 * 
 */
void MainUiSet()
{
	int i;
	u8 time_x = 18,time_y = 12,date_x=26,date_y=40;

	for(i=0;i<16;i++)
	{
		DrawChar(8*i,0, '-');
		DrawChar(8*i,50,'-');
	}
	SetFontSize(2);
	UpdateScreen();
	SetFontSize(1);
	DrawString( 2, 32, "Love you thousand years");
	UpdateScreen();
	SetFontSize(2);
}
/**
 * @brief 当进入湿度设置
 * 
 */
void Set_S_Hu(void)
{
	uint8_t button_state;
	for( uint8_t i=0; i<4; i++ )
	{
		DrawChar(0,i*16, ' ');//清除所有索引
	}
	DrawChar( 0, 2*16, "-" );//后续GuiDataDisplayRefresh会清理当前索引，所以不用担心
	UpdateScreen();
	while ( !enter_set_hu )//进入控制层
	{
		button_state = Button_Process();
		if ( button_state == Button1_Short_Press )//++
		{
			button_state = 0;
			++s_hu_setup;
		}
		else if ( button_state == Button3_Short_Press )//--
		{
			button_state = 0;
			--s_hu_setup;
		}
		else if ( button_state ==Button2_Short_Press )
		{
			button_state = 0;
			break;//跳出循环
		}
		GuiDataDisplayRefresh();
	}
	Flash_Write_Option( motor_speed_setup, s_hu_setup );//跳出循环时，将信息刷入Flash
}

/**
 * @brief 设定马达速度，再写入flash，操作和设定土壤湿度一样
 * 
 */
void Set_Mortor_Speed(void)
{
	uint8_t button_state;
	// SetFontSize(2);	
	for( uint8_t i=0; i<4; i++ )
	{
		DrawChar(0,i*16, ' ');//清除所有索引
	}
	// ClearScreen();
	UpdateScreen();
	DrawChar( 0, 1*16, "-" );
	UpdateScreen();
	enter_set_mortor = 1;
	while ( 1 )//进入控制层
	{
		button_state = Button_Process();
		if ( button_state == Button1_Short_Press )//++
		{
			button_state = 0;
			++motor_speed_setup;
		}
		else if ( button_state == Button3_Short_Press )//--
		{
			button_state = 0;
			--motor_speed_setup;
		}
		else if ( button_state ==Button2_Short_Press )
		{
			button_state = 0;
			enter_set_mortor = 0;
			break;//跳出循环
		}
		GuiDataDisplayRefresh();
	}
	Flash_Write_Option( motor_speed_setup, s_hu_setup );//跳出循环时，将信息刷入Flash
}

/**
  * @Name    DisplayRefreash
  * @brief   刷新当前菜单页的所有菜单项
  * @param   nowMenu: 当前菜单页指针
**			 selectItem: 当前菜单在当前菜单页的索引，即小光标在第几行
**           scrollBar：混动条的位置
  * @retval  void
  * @author  LQH
  * @Data    2022-01-27
  */
void DisplayRefreash(struct Menu_t *nowMenu,u8 selectItem,u8 scrollBar)
{
	int i = 0;
	static u8 lastSelectItem=0;//记录上一次的索引
	if(nowMenu==&MainUI)//当回到主菜单时，由于没有全占屏，避免上一页字迹残留，所以全刷
	{
		ClearScreen();
		MainUiSet();
	}
	else 
	{
		DrawChar(0,lastSelectItem*16, ' ');//清除上一次索引
		DrawChar(0,selectItem*16,     '>');//画出这一次索引
		for(i=0;i<(nowMenu->MenuProperty->MenuLen-nowMenu->MenuProperty->scrollBarLen);i++)
		{
			DrawString(11,i*16,nowMenu[i+scrollBar].displayString);//显示这一页的菜单项目
		}
	}
	UpdateScreen();//刷屏
	lastSelectItem = selectItem;
}
/**
  * @Name    DisplayRefreashDate
  * @brief   刷新当前菜单页的所有菜单项，主要拿来更新数据
  * @param   nowMenu:    当前菜单页指针
**			 selectItem: 当前菜单在菜单页的索引，指小光标在第几行
**           scrollBar£: 滚动条所在的位置 
  * @retval  void
  * @author  LQH
  * @Data    2022-01-27
  */
void DisplayRefreashData(struct Menu_t *nowMenu,u8 selectItem,u8 scrollBar)
{
	int i = 0;
	for(i=0;i<(nowMenu->MenuProperty->MenuLen-nowMenu->MenuProperty->scrollBarLen);i++)
	{
		DrawString(11,i*16,nowMenu[i+scrollBar].displayString);
	}
	UpdateScreen();
}

/**
  * @name    GuiInit
  * @brief   初始化菜单
  * 		 
  * @param   : 
  * @retval  void
  * @author  LQH
  * @date    2022-01-27
  */
void GuiInit()
{
	MainUI.childrenMenu = menuMain;
	menuMain[1].childrenMenu = setMenu1;//function
	menuMain[2].childrenMenu = setMenu2;//settting
	// menuMain[3].childrenMenu = setMenu3;
	menuPoint = &MainUI;
	DisplayRefreash(menuPoint,selectItem,scrollBar);
}
/**
  * @name    GuiDataDisplayRefresh
  * @brief   菜单页刷新字符串一定要占满15个
  * @param   : 
  * @retval  void
  * @author  LQH
  * @date    2022-01-27
  */
void GuiDataDisplayRefresh(void)
{
	if(menuPoint == setMenu1)
	{
		sprintf((char*)setMenu1[1].displayString,"M_Speed%3d    ",motor_speed_setup);
		sprintf((char*)setMenu1[2].displayString,"S_Hu   %3d    ",s_hu_setup);
		DisplayRefreashData(menuPoint,selectItem,scrollBar);
	}
	else if(menuPoint==setMenu2)
	{
		
		sprintf((char*)setMenu2[1].displayString,"Humi %2d %%      ",humi);
		sprintf((char*)setMenu2[2].displayString,"Temp %2d C      ",temp-7);
		sprintf((char*)setMenu2[3].displayString,"S_Hu %2d %%      ",solid_humi);
		DisplayRefreashData(menuPoint,selectItem,scrollBar);
	}
	else if(menuPoint==&MainUI)
	{
		MainUiSet();
		UpdateScreen();
	}
}
/**
  * @Name    GuiControl
  * @brief   按键控制.
  * @param   : 输入/出
  * @retval  void
  * @author  LQH
  * @Data    2022-01-27
  */
void GuiControl()
{
	uint8_t Button_state = 0x00;
	Button_state =  Button_Process();
	if(Button_state==Button1_Short_Press)//上键按下
	{
		Button_state=0;//标志位清零
		selectItem--;//当前菜单页的索引--
		if(selectItem<0&&scrollBar!=0)//小于0,滚动条不在0，就喊滚动条
		{
			selectItem = 0;
			scrollBar--;
		}else if(selectItem<0&&scrollBar==0)//小于0,滚动条也在0，就将索引调到最后，滚动条最大
		{
			selectItem = menuPoint->MenuProperty->MenuLen-1-menuPoint->MenuProperty->scrollBarLen;
			scrollBar  = menuPoint->MenuProperty->scrollBarLen;
		}
		DisplayRefreash(menuPoint,selectItem,scrollBar);//刷新显示
	}else if(Button_state == Button3_Short_Press)//同理
	{
		Button_state=0;
		selectItem++;
		//假如索引大于最大值，但滚动条不在最大值，保持索引最大值，滚动条++
		if(selectItem>(menuPoint->MenuProperty->MenuLen-1-menuPoint->MenuProperty->scrollBarLen)&&scrollBar!=menuPoint->MenuProperty->scrollBarLen)
		{
			selectItem = menuPoint->MenuProperty->MenuLen-1-menuPoint->MenuProperty->scrollBarLen;
			scrollBar++;
			
		}
		//假如索引大于最大值，滚动条在最大值，移动到第一个位置
		else if(selectItem>(menuPoint->MenuProperty->MenuLen-1-menuPoint->MenuProperty->scrollBarLen)&&scrollBar==menuPoint->MenuProperty->scrollBarLen)
		{
			selectItem=0;
			scrollBar =0;
		}
		DisplayRefreash(menuPoint,selectItem,scrollBar);
	}
	else if(Button_state== Button2_Short_Press )//进入菜单功能
	{
		if(selectItem==0 && scrollBar==0 && menuPoint[selectItem].fatherMenu!=NULL)//假如索引为0而且父菜单不为0，指向父指针
		{
			menuPoint = menuPoint[selectItem].fatherMenu;
			ClearScreen();//进入父对象界面，即退出，清空一次页面，防止残留
			UpdateScreen();
		}
		else if(menuPoint[selectItem+scrollBar].childrenMenu!=NULL)//假如该索引子菜单不为空，指向子菜单
		{
			if(menuPoint[selectItem+scrollBar].func2!=NULL)//假如当前菜单的fun2不为空，执行fun2
			{
				menuPoint[selectItem+scrollBar].func2();
			}
			menuPoint = menuPoint[selectItem+scrollBar].childrenMenu;
			selectItem = 0;
			ClearScreen();//进入子对象界面，即进入，清空一次页面，防止残留
			UpdateScreen();
		}
		else if(menuPoint[selectItem+scrollBar].func2!=NULL)//假如当前菜单fun2不为空，执行fun2
		{
			menuPoint[selectItem+scrollBar].func2();
		}
		Button_state=0;
		DisplayRefreash(menuPoint,selectItem,scrollBar);
	}
	// GuiDataDisplayRefresh();
}

