#include <stdio.h>
#include "n32l40x.h"
#include "main.h"
#include "draw_api.h"
#include "test.h"

static void GPIO_Init_Configuration(void);
static uint8_t button_status = 0x00;
__IO uint16_t ADCConvertedValue;//含水量100％的时候 2300
int8_t motor_level = 0;
extern uint8_t solid_humi;

extern struct Menu_t *menuPoint;
extern struct Menu_t setMenu1[3];
extern struct Menu_t setMenu2[4];

u8 data[6];
uint8_t temp;
uint8_t humi;

uint8_t s_hu_setup;
uint8_t motor_speed_setup;
uint32_t setting_value;

// float Volatage=0;//不使用转换成电压的方式测定土壤湿度 含水量100％的时候 1.72V

void Delay(uint32_t nCount)
{
    uint32_t tcnt;
    while(nCount--)
    {
        tcnt = 64000 / 5;
        while (tcnt--){;}
    }
}


int main()
{
    USART2_Init();  
    TIM_init();
    Motor_TIM_Init();
    Moisture_Init();
    Button_Init();    
    GPIO_Init_Configuration();
    I2C_Configuration();
    OLED_Init();
    
    I2C2_Configuration();

    delay_us(1);
    delay_ms(2);//初始化延时以后需要开启一次延时

    setting_value = Flash_Read_Data( FLASH_WRITE_START_ADDR );
    
    printf( "System setup" );
    // Flash_Write_Option( 5, 90 );

    printf( "\r\nOption Speed is %d", (uint8_t) ( setting_value >>8 ) );
    printf( "\r\nOption S_Hu is %d", (uint8_t) ( setting_value ) );

    motor_speed_setup = (uint8_t) ( setting_value>>8 );
    s_hu_setup        = (uint8_t) ( setting_value );

    SHT30_Write(0x20, 0x32);
    SetFontSize( 2 );
    DrawString( 20, 16, "Here is" );
    DrawString( 40,35, "OLED" );
    UpdateScreen();
    delay_ms(1000);
    ClearScreen();
    UpdateScreen();
    GPIO_WriteBit( GPIOA, GPIO_PIN_8, Bit_SET );
    // demo();
	GuiInit();
    while(1)
    {
        // button_status = Button_Process();
        // if( button_status == Button1_Short_Press)
        // {
        //     Motor_Speed( ++motor_level );
        // }
        // else if ( button_status == Button3_Short_Press )
        // {
        //     Motor_Speed( --motor_level );
        // }
        
        // printf( "ADC value is %d", ADCConvertedValue );
        
        // delay_ms(500);
        solid_humi = (ADCConvertedValue/26);
        if (SHT30_ReadTempAndHumi(data) == 0) {//获取温湿度值
            if( SHT30_Dat_To_Float( data, &temp, &humi ) ==0 )//检测环境参数是否过CRC校验和
            {

            }
		}
        if( menuPoint == setMenu2 )//在参数页执行
        {
            if( solid_humi < s_hu_setup )//小于设定值时
            {
                Motor_Speed( motor_speed_setup );//开启马达到对应的速度
                
            }
            else
            {
                Motor_Speed(0);//否则关闭
            }
            
            delay_ms(100);//检测灵敏度 100ms+10ms = 110ms
        }
        printf( "ADC value is %d", ADCConvertedValue );
		GuiControl();//GUI控制（刷屏）
		GuiDataDisplayRefresh();//刷新数据
        delay_ms(10);
        
    }
}

static void GPIO_Init_Configuration(void)
{
    GPIO_InitType GPIO_Init_Structure;

    GPIO_Init_Structure.Pin = GPIO_PIN_8;
    GPIO_Init_Structure.GPIO_Mode = GPIO_Mode_Out_PP;
    GPIO_Init_Structure.GPIO_Pull = GPIO_No_Pull;
    GPIO_Init_Structure.GPIO_Current = GPIO_DC_4mA;
    GPIO_Init_Structure.GPIO_Slew_Rate = GPIO_Slew_Rate_High;

    GPIO_InitPeripheral( GPIOA, &GPIO_Init_Structure );
}
