#include "oled_driver.h"
#include "delay.h"

#if (TRANSFER_METHOD ==HW_IIC)
//I2C_ConfigurationʼӲIIC
void I2C_Configuration(void)
{
	I2C_InitType  I2C_InitStructure;
	GPIO_InitType  GPIO_InitStructure; 

	RCC_EnableAPB1PeriphClk(IIC_RCC_APB1Periph_I2CX,ENABLE);
	RCC_EnableAPB2PeriphClk(IIC_RCC_APB2Periph_GPIOX,ENABLE);
	// RCC_EnableAPB2PeriphClk(RCC_APB2_PERIPH_AFIO, ENABLE);

	GPIO_InitStructure.Pin =  IIC_SCL_Pin_X | IIC_SDA_Pin_X;
	GPIO_InitStructure.GPIO_Slew_Rate = GPIO_Slew_Rate_Low;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_OD;//I2C뿪©
	GPIO_InitStructure.GPIO_Alternate = GPIO_AF1_I2C1;
	GPIO_InitStructure.GPIO_Pull = GPIO_Pull_Up;
	GPIO_InitPeripheral(IIC_GPIOX, &GPIO_InitStructure);	

	I2C_DeInit(I2CX);
	I2C_InitStructure.BusMode = I2C_BUSMODE_I2C;
	I2C_InitStructure.FmDutyCycle = I2C_FMDUTYCYCLE_2;
	I2C_InitStructure.OwnAddr1 = 0x30;//I2Cַ,д
	I2C_InitStructure.AckEnable = I2C_ACKDIS;
	I2C_InitStructure.AddrMode = I2C_ADDR_MODE_7BIT;
	I2C_InitStructure.ClkSpeed = 400000;

	I2C_Init(I2CX, &I2C_InitStructure);
	I2C_Enable(I2CX, ENABLE);
	
	// delay_us(200);
}

 /**
  * @brief  I2C_WriteByteOLEDĴַдһbyte
  * @param  addrĴַ
	*					dataҪд
  * @retval 
  */
void I2C_WriteByte(uint8_t addr,uint8_t data)
{
 	while(I2C_GetFlag(I2CX, I2C_FLAG_BUSY));
	
	I2C_GenerateSTART(I2CX, ENABLE);//I2C1
	while(!I2C_CheckEvent(I2CX, I2C_EVT_MASTER_MODE_FLAG));/*EV5,ģʽ*/
	
	I2C_Send7bitAddress(I2CX, OLED_ADDRESS, I2C_DIRECTION_SEND);//ַ -- Ĭ0x78
	while(!I2C_CheckEvent(I2CX, I2C_EVT_MASTER_TXMODE_FLAG));
	
	I2C_SendData(I2CX, addr);//Ĵַ
	while (!I2C_CheckEvent(I2CX, I2C_EVT_MASTER_DATA_SENDING));

	I2C_SendData(I2CX, data);//
	while (!I2C_CheckEvent(I2CX, I2C_EVT_MASTER_DATA_SENDED));
	
	I2C_GenerateStop(I2CX, ENABLE);//رI2C1
}

void WriteCmd(unsigned char cmd)//д
{
		I2C_WriteByte(0x00, cmd);
}

void WriteDat(unsigned char dat)//д
{
		I2C_WriteByte(0x40, dat);
}
// /**
//  * @brief ָˢдֻˢһpage
//  * 
//  * @param BMP 
//  */
// void OLED_FILL(unsigned char BMP[])
// {
// 		unsigned int  j;
// 		unsigned char *p;
// 		p=BMP;
// 		WriteCmd(0xb0);		//page0-page1
// 		WriteCmd(0x00);		//low column start address
// 		WriteCmd(0x10);		//high column start address
// 		while(I2C_GetFlagStatus(I2CX, I2C_FLAG_BUSY));	
// 		I2C_GenerateSTART(I2C1, ENABLE);//I2C1
// 		while(!I2C_CheckEvent(I2CX, I2C_EVT_MASTER_MODE_FLAG));/*EV5,ģʽ*/
// 		I2C_Send7bitAddress(I2CX, OLED_ADDRESS, I2C_DIRECTION_SEND);//ַ -- Ĭ0x78
// 		while(!I2C_CheckEvent(I2CX, I2C_EVT_MASTER_TXMODE_FLAG));
// 		I2C_SendData(I2CX, 0x40);//Ĵַ
// 		while (!I2C_CheckEvent(I2CX, I2C_EVT_MASTER_DATA_SENDING));
// 		// for(i=0; i<8; i++)
// 		// {
// 			for(j=0;j<128*8;j++)
// 			{
// 				I2C_SendData(I2CX, *p++);//
// 				while (!I2C_CheckEvent(I2CX, I2C_EVT_MASTER_DATA_SENDING));
// 			}	
// 		// }	

// 		I2C_GenerateStop(I2CX, ENABLE);//رI2C1
// }

/**
 * @brief ˢ
 * 
 * @param BMP 
 */
void OLED_FILL(unsigned char BMP[])//
{
// 		unsigned int  j;
		unsigned char *p;
		p=BMP;
	unsigned char m,n;
	for(m=0;m<8;m++)
	{
		WriteCmd(0xb0+m);		//page0-page1
		WriteCmd(0x00);		//low column start address
		WriteCmd(0x10);		//high column start address
		for(n=0;n<128;n++)
		{
				WriteDat(*p++);
		}
	}
}

// void OLED_FILL(unsigned char BMP[])
// {
// 	u8 i,j;
// 	unsigned char *p;
// 	p=BMP;

//   for(i=0;i<8;i++)
// 	{
// 		WriteCmd(0xb0+i);		//page0-page1
// 		WriteCmd(0x00);		//low column start address
// 		WriteCmd(0x10);	

// 		for(j=0;j<128;j++)
// 		{
// 			WriteDat(*p++);
// 		}
// 	}
// }

#elif  (TRANSFER_METHOD ==SW_IIC)

#elif  (TRANSFER_METHOD ==HW_SPI)

	#define OLED_RESET_LOW()					GPIO_ResetBits(SPI_RES_GPIOX, SPI_RES_PIN)	//͵ƽλ
	#define OLED_RESET_HIGH()					GPIO_SetBits(SPI_RES_GPIOX, SPI_RES_PIN)
	 
	#define OLED_CMD_MODE()						GPIO_ResetBits(SPI_DC_GPIOX, SPI_DC_PIN) 		//ģʽ
	#define OLED_DATA_MODE()					GPIO_SetBits(SPI_DC_GPIOX, SPI_DC_PIN)			//ģʽ

	#define OLED_CS_HIGH()   					GPIO_SetBits(SPI_CS_GPIOX, SPI_CS_Pin_X)
	#define OLED_CS_LOW()  		  			GPIO_ResetBits(SPI_CS_GPIOX, SPI_CS_Pin_X)
	
	
void SPI_Configuration(void)
{
	SPI_InitTypeDef  SPI_InitStructure;
	GPIO_InitTypeDef GPIO_InitStructure;
	#if 	(USE_HW_SPI==SPI_2)
		RCC_APB1PeriphClockCmd(SPI_RCC_APB1Periph_SPIX, ENABLE);
	#elif (USE_HW_SPI==SPI_1)
		RCC_APB2PeriphClockCmd(SPI_RCC_APB2Periph_SPIX, ENABLE);
	#endif
	RCC_APB2PeriphClockCmd(SPI_RCC_APB2Periph_GPIOX|RCC_APB2Periph_AFIO,ENABLE);
	
	GPIO_InitStructure.GPIO_Pin = SPI_CS_Pin_X;
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
	GPIO_Init(SPI_CS_GPIOX, &GPIO_InitStructure);  
	OLED_CS_HIGH();
	
	GPIO_InitStructure.GPIO_Pin = SPI_HW_ALL_PINS;
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;
	GPIO_Init(SPI_HW_ALL_GPIOX, &GPIO_InitStructure);   
	
	
	SPI_InitStructure.SPI_Direction = SPI_Direction_2Lines_FullDuplex;//SPI_Direction_1Line_Tx; 
	SPI_InitStructure.SPI_Mode = SPI_Mode_Master;	 			
	SPI_InitStructure.SPI_DataSize = SPI_DataSize_8b;	 	
	SPI_InitStructure.SPI_CPOL = SPI_CPOL_Low;		 	
	SPI_InitStructure.SPI_CPHA = SPI_CPHA_1Edge;		
	SPI_InitStructure.SPI_NSS = SPI_NSS_Soft;		  
	SPI_InitStructure.SPI_BaudRatePrescaler = SPI_BaudRatePrescaler_2;
	SPI_InitStructure.SPI_FirstBit = SPI_FirstBit_MSB;  			
	SPI_InitStructure.SPI_CRCPolynomial = 7;
	
	SPI_Init(SPIX, &SPI_InitStructure);  
	SPI_Cmd(SPIX, ENABLE);
	
	GPIO_InitStructure.GPIO_Pin = SPI_RES_PIN;
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
	GPIO_Init(SPI_RES_GPIOX, &GPIO_InitStructure);  
	GPIO_InitStructure.GPIO_Pin = SPI_DC_PIN;
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
	GPIO_Init(SPI_DC_GPIOX, &GPIO_InitStructure);  
	OLED_DATA_MODE();
	
	OLED_RESET_HIGH();
	WaitTimeMs(100);
	OLED_RESET_LOW();
	WaitTimeMs(100);
	OLED_RESET_HIGH();
}

void SPI_WriterByte(unsigned char dat)
{

	while (SPI_I2S_GetFlagStatus(SPIX, SPI_I2S_FLAG_TXE) == RESET ){}; //ָSPI־λ:ͻձ־λ	  
		SPI_I2S_SendData(SPIX, dat); //ͨSPIxһ
	while (SPI_I2S_GetFlagStatus(SPIX, SPI_I2S_FLAG_RXNE) == RESET){};//ָSPI־λ:ܻǿձ־λ  						    
	  SPI_I2S_ReceiveData(SPIX); //ͨSPIxյ	

}

void WriteCmd(unsigned char cmd)
{
	OLED_CMD_MODE();
	OLED_CS_LOW();
	SPI_WriterByte(cmd);
	OLED_CS_HIGH();
	OLED_DATA_MODE();
}

void WriteDat(unsigned char dat)
{
	OLED_DATA_MODE();
	OLED_CS_LOW();
	SPI_WriterByte(dat);
	OLED_CS_HIGH();
	OLED_DATA_MODE();
}

void OLED_FILL(unsigned char BMP[])
{
	u8 i,j;
	unsigned char *p;
	p=BMP;

  for(i=0;i<8;i++)
	{
		WriteCmd(0xb0+i);		//page0-page1
		WriteCmd(0x00);		//low column start address
		WriteCmd(0x10);	

		for(j=0;j<128;j++)
		{
			WriteDat(*p++);
		}
	}
}

#endif //(TRANSFER_METHOD ==HW_IIC)

void OLED_Init(void)
{
	// WriteCmd(0xAE); //display off
	// WriteCmd(0x20);	//Set Memory Addressing Mode	
	// WriteCmd(0x10);	//00,Horizontal Addressing Mode;01,Vertical Addressing Mode;10,Page Addressing Mode (RESET);11,Invalid
	// WriteCmd(0xb0);	//Set Page Start Address for Page Addressing Mode,0-7
	// WriteCmd(0xc8);	//Set COM Output Scan Direction
	// WriteCmd(0x02); //---set low column address
	// WriteCmd(0x10); //---set high column address
	// WriteCmd(0x40); //--set start line address
	// WriteCmd(0x81); //--set contrast control register
	// WriteCmd(0xff); //ȵ 0x00~0xff
	// WriteCmd(0xa1); //--set segment re-map 0 to 127
	// WriteCmd(0xa6); //--set normal display
	// WriteCmd(0xa8); //--set multiplex ratio(1 to 64)
	// WriteCmd(0x3F); //
	// WriteCmd(0xa4); //0xa4,Output follows RAM content;0xa5,Output ignores RAM content
	// WriteCmd(0xd3); //-set display offset
	// WriteCmd(0x00); //-not offset
	// WriteCmd(0xd5); //--set display clock divide ratio/oscillator frequency
	// WriteCmd(0xf0); //--set divide ratio
	// WriteCmd(0xd9); //--set pre-charge period
	// WriteCmd(0x22); //
	// WriteCmd(0xda); //--set com pins hardware configuration
	// WriteCmd(0x12);
	// WriteCmd(0xdb); //--set vcomh
	// WriteCmd(0x20); //0x20,0.77xVcc
	// WriteCmd(0x8d); //--set DC-DC enable
	// WriteCmd(0x14); //

	// WriteCmd(0xAE); /*display off*/ 
	// WriteCmd(0x20); /*set lower column address*/ 
	// WriteCmd(0x10); /*set higher column address*/ 
	// WriteCmd(0x40); /*set display start line*/ 
	// WriteCmd(0xB0); /*set page address*/
	// WriteCmd(0x81); /*contract control*/ 
	// WriteCmd(0xcf); /*128*/ 
	// WriteCmd(0xA1); /*set segment remap*/ 
	// WriteCmd(0xA6); /*normal / reverse*/ 
	// WriteCmd(0xA8); /*multiplex ratio*/ 
	// WriteCmd(0x3F); /*duty = 1/64*/ 
	// WriteCmd(0xad); /*set charge pump enable*/ 
	// WriteCmd(0x8b); /* 0x8B ???? VCC */ 
	// WriteCmd(0x33); /*0X30---0X33 set VPP 9V */ 
	// WriteCmd(0xC8); /*Com scan direction*/ 
	// WriteCmd(0xD3); /*set display offset*/ 
	// WriteCmd(0x00); /* 0x20 */ 
	// WriteCmd(0xD5); /*set osc division*/ 
	// WriteCmd(0x80); 
	// WriteCmd(0xD9); /*set pre-charge period*/ 
	// WriteCmd(0x1f); /*0x22*/ 
	// WriteCmd(0xDA); /*set COM pins*/ 
	// WriteCmd(0x12); 
	// WriteCmd(0xdb); /*set vcomh*/ 
	// WriteCmd(0x40);

  OLED_WriteCmd(0xAE); //رʾ0xAEرOLED0xAFOLED
  OLED_WriteCmd(0x20);  //GDDRAMѰַģʽ  
  OLED_WriteCmd(0x10);  //00ˮƽѰַģʽ; 01ֱѰַģʽ; 10ҳѰַģʽ;
  OLED_WriteCmd(0xb0);  //ҳѰַģʽҳʼλ
  OLED_WriteCmd(0xc8);  //ɨ跽
  OLED_WriteCmd(0x00); //еַʼַλ
  OLED_WriteCmd(0x10); //еַʼַλ
  OLED_WriteCmd(0x40); //GDDRAMʼ
  OLED_WriteCmd(0x81); //öԱȶ
  OLED_WriteCmd(0xff); //ȵ 0x00~0xff
  OLED_WriteCmd(0xa1); //ҷù
  OLED_WriteCmd(0xa6); //ʾģʽ
  OLED_WriteCmd(0xa8); //ø
  OLED_WriteCmd(0x3F); 
  OLED_WriteCmd(0xa4); //GDDRAMеʾ
  OLED_WriteCmd(0xd3); //ʾƫ
  OLED_WriteCmd(0x00); //ƫ
  OLED_WriteCmd(0xd5); //ʱ
  OLED_WriteCmd(0xf0); 
  OLED_WriteCmd(0xd9); //Ԥ
  OLED_WriteCmd(0x22); //
  OLED_WriteCmd(0xda); //Ӳ
  OLED_WriteCmd(0x12);
  OLED_WriteCmd(0xdb); //Vcomh
  OLED_WriteCmd(0x20); //0.77*Vcc
  OLED_WriteCmd(0x8d); //õɱ
  OLED_WriteCmd(0x14); //õɱ
//   OLED_WriteCmd(0xaf); //OLEDʾ

	OLED_CLS();
	WriteCmd(0xAF); /*display ON*/
}


void OLED_CLS(void)//
{
	unsigned char m,n;
	for(m=0;m<8;m++)
	{
		WriteCmd(0xb0+m);		//page0-page1
		WriteCmd(0x00);		//low column start address
		WriteCmd(0x10);		//high column start address
		for(n=0;n<132;n++)
		{
				WriteDat(0x00);
		}
	}
}

void OLED_ON(void)
{
	WriteCmd(0X8D);  //õɱ
	WriteCmd(0X14);  //ɱ
	WriteCmd(0XAF);  //OLED
}



void OLED_OFF(void)
{
	WriteCmd(0X8D);  //õɱ
	WriteCmd(0X10);  //رյɱ
	WriteCmd(0XAE);  //OLED
}



