#ifndef __OLED_DRIVER_H
#define	__OLED_DRIVER_H
#include "n32l40x.h"
#include "oled_config.h"
#include "oled_basic.h"

#define I2C_GenerateSTART(I2CX, CMD)                    I2C_GenerateStart(I2CX, CMD)
#define I2C_Send7bitAddress(I2CX, ADDR, I2C_DIRECTION)  I2C_SendAddr7bit( I2CX, ADDR, I2C_DIRECTION )
#define I2C_GetFlagStatus(I2CX, FLAG)                   I2C_GetFlag(I2CX, FLAG)
#define OLED_WriteCmd(data)                             WriteCmd(data)

#if (TRANSFER_METHOD ==HW_IIC)

	#if (USE_HW_IIC ==IIC_1)
		#define OLED_ADDRESS	0x7A //ͨ0R,0x780x7Aַ -- Ĭ0x78
		/*STM32F103C8T6оƬӲI2C: PB6 -- SCL; PB7 -- SDA */
		#define IIC_RCC_APB1Periph_I2CX   	RCC_APB1_PERIPH_I2C1
		#define IIC_RCC_APB2Periph_GPIOX  	RCC_APB2_PERIPH_GPIOB
		#define IIC_GPIOX                		GPIOB
		#define IIC_SCL_Pin_X								GPIO_PIN_6
		#define IIC_SDA_Pin_X        				GPIO_PIN_7
		#define I2CX                  			I2C1
	#elif (USE_HW_IIC ==IIC_2)
		#define IIC_RCC_APB1Periph_I2CX   	RCC_APB1Periph_I2C2
		#define IIC_RCC_APB2Periph_GPIOX  	RCC_APB2Periph_GPIOB
		#define IIC_GPIOX                		GPIOB
		#define IIC_SCL_Pin_X								GPIO_Pin_10
		#define IIC_SDA_Pin_X       			 	GPIO_Pin_11
		#define I2CX                  			I2C2
	#endif
	
#elif (TRANSFER_METHOD ==SW_IIC)



#elif (TRANSFER_METHOD ==HW_SPI)
	
	#if (USE_HW_SPI==SPI_1)
		
		
		
	#elif (USE_HW_SPI==SPI_2)
		#define SPIX                      SPI2
		//ʹSPI2ʱ
		#define SPI_RCC_APB1Periph_SPIX   RCC_APB1Periph_SPI2
		//ʹgpioʱӣʹõGPIOһʱɶ£
		//#define SPI_RCC_APB2Periph_GPIOX	RCC_APB2Periph_GPIOB|RCC_APB2Periph_GPIOC
		#define SPI_RCC_APB2Periph_GPIOX	RCC_APB2Periph_GPIOB	
		//CSƬѡƬѡ
		#define SPI_CS_Pin_X              GPIO_Pin_12
		#define SPI_CS_GPIOX							GPIOB
		//SPI2 ʱӡmosimiso
		#define SPI_HW_ALL_PINS          	(GPIO_Pin_13|GPIO_Pin_14|GPIO_Pin_15) 
		#define SPI_HW_ALL_GPIOX					GPIOB
		//λ
		#define SPI_RES_PIN 							GPIO_Pin_10
		#define SPI_RES_GPIOX							GPIOB
		//
		#define SPI_DC_PIN 								GPIO_Pin_11
		#define SPI_DC_GPIOX							GPIOB
	#endif

#elif (TRANSFER_METHOD ==SW_SPI)


#endif

typedef enum
{
    NONE = 0,
    TRANSMIT,
    RECEIVE
} TR_STA;

typedef enum
{
    C_READY = 0,
    C_START_BIT,
    C_STOP_BIT
}CommCtrl_t;

typedef enum
{
    MASTER_OK = 0,
    MASTER_BUSY,
    MASTER_MODE,
    MASTER_TXMODE,
    MASTER_RXMODE,
    MASTER_SENDING,
    MASTER_SENDED,
    MASTER_RECVD,
    MASTER_BYTEF,
    MASTER_BUSERR,
    MASTER_UNKNOW,
    SLAVE_OK = 20,
    SLAVE_BUSY,
    SLAVE_MODE,
    SLAVE_BUSERR,
    SLAVE_UNKNOW,

}ErrCode_t;

#define MODULE_SELF_RESET       1
#define MODULE_RCC_RESET        2
#define SYSTEM_NVIC_RESET       3
#define COMM_RECOVER_MODE       0


void I2C_Configuration(void);
void I2C_WriteByte(uint8_t addr,uint8_t data);
void SPI_Configuration(void);
void SPI_WriterByte(unsigned char dat);
void WriteCmd(unsigned char cmd);
void WriteDat(unsigned char Dat);
void OLED_Init(void);
void OLED_CLS(void);
void OLED_ON(void);
void OLED_OFF(void);
void OLED_FILL(unsigned char BMP[]);

#endif //__OLED_DRIVER_H
